#include <bits/stdc++.h>
using namespace std;

using ll = long long int;
using ld = long double;
#define N 200000
#define pii pair<int,int>
#define mk make_pair

int n;
vector<int> G[N];
int d[N], cnt[N];
priority_queue<pii> Q;

int main(void) {
    ios_base::sync_with_stdio(false);
    cin >> n;
    for(int i=1, u, v;i<n;++i) {
        cin >> u >> v;
        --u;--v;
        G[u].push_back(v);
        G[v].push_back(u);
        ++d[u];
        ++d[v];
    }
    for(int i=0;i<n;++i) {
        cnt[i] = 1;
        if(d[i] == 1) {
            Q.push(mk(-cnt[i], i));
        }
    }
    while(!Q.empty()) {
        int u = Q.top().second;
        // cerr<<u<<endl;
        Q.pop();
        if(d[u] == 0) continue;
        for(int v : G[u]) {
            if(d[v] > 0) {
                // cerr << u << "," << cnt[u] <<".."<<v<<","<<cnt[v]<<endl;
                if(cnt[u] <= cnt[v]) {
                    cnt[v] += cnt[u];
                    --d[v];
                    if(d[v] == 1) {
                        Q.push(mk(-cnt[v], v));
                    }
                } else {
                    cout << "NO" <<endl;
                    return 0;
                }
                break;
            }
        }
        cnt[u] = d[u] = 0;
    }

    for(int i=0;i<n;++i) {
        if(d[i] > 0) {
            cout << "NO" <<endl;
            return 0;
        }
    }
    cout << "YES" << endl;
    return 0;
}