#include <bits/stdc++.h>
using namespace std;

#define N 200000
#define M 1000000

int n, m;
unordered_set<int> S[N];
int T[M], id[N];
bool contenu[N];

int comp(int x, int y) {
    return S[x].size() < S[y].size();
}

bool subset(int x, int y) {
    for(int t : S[x]) {
        if(S[y].count(t) == 0)
            return false;
    }
    return true;
}

int main(void) {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    memset(T, -1, sizeof(T));
    cin >> n >> m;
    for(int i=0;i<n;++i) {
        id[i] = i;
        int l;
        cin >> l;
        for (int j = 0, x; j < l; ++j) {
            cin >> x;
            S[i].insert(x-1);
        }
    }
    sort(id, id+n, comp);
    for(int i=0;i<n;++i) {
        int u = id[i];
        for(int x : S[u]) {
            if(T[x] == -1 || contenu[T[x]] || subset(T[x], u)) {
                if(T[x] != -1) contenu[T[x]] = true;
                T[x] = u;
            } else {
                cout << "YES\n" << T[x]+1 << " " << u+1 << "\n";
                return 0;
            }
        }
    }
    cout << "NO\n";
    return 0;
}