#include <bits/stdc++.h>
using namespace std;

using ll = long long int;
using ld = long double;
#define N 1000

int n;
ll x[N], y[N], r[N];
int col[N];
vector<int> G[N];

bool adj(int u, int v) {
    return (x[u]-x[v])*(x[u]-x[v]) + (y[u]-y[v])*(y[u]-y[v]) == (r[u]+r[v])*(r[u]+r[v]);
}

int acc;
bool fl;

void dfs(int u) {
    acc += col[u];
    for(int v : G[u]) {
        if(col[v] == 0) {
            col[v] = -col[u];
            dfs(v);
        } else if(col[v] == col[u]) {
            fl = false;
        }
    }
}


int main() {
    cin >> n;
    for(int i=0;i<n;++i) {
        cin >> x[i] >> y[i] >> r[i];
    }
    for(int i=0;i<n;++i) {
        for(int j=i+1;j<n;++j) {
            if(adj(i, j)) {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }
    for(int i=0;i<n;++i) if(col[i] == 0) {
        acc = 0;
        fl = true;
        col[i] = 1;
        dfs(i);
        if(fl && acc != 0) {
            cout << "YES" << endl;
            return 0;
        }
    }
    cout << "NO" << endl;
    return 0;
}
